/***************************************************************************
 *   Copyright (C) 2004 by Adrien Auclair                                  *
 *   adrien.auclair@club-internet.fr                                       *
 *                                                                         *
 ***************************************************************************/

#include <assert.h>
#include "mytools_spline.h"

namespace mytools_spline
{
 void
 Catmull_Get_Point_1D( double t , double * p1 , double * p2 , double * p3 , double * p4 , double * result)
 {
	assert( t>=-0.0001 && t <= 1.0001);

	result[0] = t*t*t*(-0.5*p1[0]+1.5*p2[0]-1.5*p3[0]+0.5*p4[0])
		  + t*t*(p1[0]-2.5*p2[0]+2.0*p3[0]-0.5*p4[0])
		  + t * (-0.5*p1[0]+0.5*p3[0] )
		  + p2[0];

	result[1] = t*t*t*(-0.5*p1[1]+1.5*p2[1]-1.5*p3[1]+0.5*p4[1])
		  + t*t*(p1[1]-2.5*p2[1]+2.0*p3[1]-0.5*p4[1])
		  + t * (-0.5*p1[1]+0.5*p3[1] )
		  + p2[1];

	result[2] = t*t*t*(-0.5*p1[2]+1.5*p2[2]-1.5*p3[2]+0.5*p4[2])
		  + t*t*(p1[2]-2.5*p2[2]+2.0*p3[2]-0.5*p4[2])
		  + t * (-0.5*p1[2]+0.5*p3[2] )
		  + p2[2];
 }



void
Catmull_Get_Point_2D( double u,double v, double * l1 , double *l2 , double *l3 , double * l4 , double * result)
{
	double p1[3],p2[3],p3[3],p4[3];
	mytools_spline::Catmull_Get_Point_1D( u , &(l1[0]) , &(l1[3]) , &(l1[6]) , &(l1[9]) , p1);
	mytools_spline::Catmull_Get_Point_1D( u , &(l2[0]) , &(l2[3]) , &(l2[6]) , &(l2[9]) , p2);
	mytools_spline::Catmull_Get_Point_1D( u , &(l3[0]) , &(l3[3]) , &(l3[6]) , &(l3[9]) , p3);
	mytools_spline::Catmull_Get_Point_1D( u , &(l4[0]) , &(l4[3]) , &(l4[6]) , &(l4[9]) , p4);

	mytools_spline::Catmull_Get_Point_1D( v , p1 , p2 , p3 , p4 , result);

}

}