/***************************************************************************
 *   Copyright (C) 2004 by Adrien Auclair                                  *
 *   adrien.auclair@club-internet.fr                                       *
 *                                                                         *
 ***************************************************************************/

 #ifndef MYTOOLS_SPLINE
 #define MYTOOLS_SPLINE


 namespace mytools_spline
 {
  	/// calcule le point d'abcisse t sur le catmull-rom spline  1 Dimension
	/**
	* @param double t : abcisse du point ( val ezntre 0 et 1)
	* @param double *p1,p2,p3,p4 : tableau des coordonnes des 4 points
	* @param double *result  : adresse tableau de coord du point calcul  remplir
	*/
  	void Catmull_Get_Point_1D( double t , double * p1 , double *p2 , double * p3 , double * p4 , double * result);

	/// calcule le point (u,v) sur le catmull-rom spline  2 Dimension
	/**
	* @param double u : abcisse du point ( val ezntre 0 et 1)
	* @param double v : ordonne du point ( val ezntre 0 et 1)
	* @param double *l1,l2,l3,l4 : lignes de 4 points du patch
	* par exemple l1 contient les coords des 4 points de plus faible ordonne
	* @param double *result  : adresse tableau de coord du point calcul  remplir
	*/
  	void Catmull_Get_Point_2D( double u , double v , double * l1 , double *l2 , double *l3 , double * l4 , double * result);
 };



 #endif
